<?php
/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Geeklog SiteCalendar Block version 2.3                                    |
// | Only Supported with Geeklog 1.3.8 and new Search Class                    |
// +---------------------------------------------------------------------------+
// | main.php                                                                  |
// | Main program to view site calendar that displays GL Calendar              |
// | events and hooks into the GL search to show any site updates              |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2000,2001 by the following authors:                         |
// | Geeklog Author: Tony Bibbs       - tony@tonybibbs.com                     |
// | Block Author:   Blaine Lang      - geeklog@langfamily.ca                  |
// | Original PHP Calendar by Scott Richardson - srichardson@scanonline.com    |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
// Release History
/********************************************************************************
* June 12/2002: Blaine Lang                                                     *
* Modified to work with Geeklog - structured as functions                       *
* and building HTML output to be called as a phpblock and                       *
*                                                                               *
* Sept 2/02: Fixed a bug where today was not being higlighted in the next month *
* Changed all occurances of $InThisMonth to $GLOBALS['InThisMonth']             *
*                                                                               *
* Sept 15/02: Version 2.0                                                       *
* ALmost a complete re-write, code restructured                                 *
* Integrated vesion with Site Search and Events Calendar                        *
* Displayed dates are now active hyperlinks to search results for that day      *
* Added ability to view next/prev months                                        *
* Now using Template classes for fonts                                          *
* Fixed bug with extra week showing up occasionally                             *
*                                                                               *
* Sept 16/02: Fixed bug where I was not checking access to events that were     *
* displayed on the calendar - added access checks.                              *
* Note: Currently only checking system calendar for events  - not personal      *
* Nov 08/02: Gorka Olaizola <gorka@escomposlinux.org>                           *
*    Fixed dates when week starts in previous month                             *
*    Fixed dates when switching years                                           *
*    Added setlocale and strftime for printing the month in local language      *
*                                                                               *
* Dec 03/02: Replaced a couple HTML fixes that had been made since the version  *
* used by Gorka when he did his changes                                         *
*                                                                               *
* January 25/2003: Stephen Magyari                                              *
* Removed the height=100% attribute from the first and last tables in           *
* $BlockDisplay to address a display anomaly in IE 5.2 on Mac OS X, added a     *
* missing </tr> after the month header, and added class="mycallink" attribute   *
* to the 3 occurrences of $event_url                                            *
*                                                                               *
* Feb 01/2003: Blaine Lang                                                      *
* Fixed sellocale() error displayed that occured under PHP 4.3                  *
*                                                                               *
*                                                                               *
* Jul 19/2003: Blaine Lang                                                      *
* Modified for Geeklog 1.3.8 - Core GL Search completely replaced               *
* New Search Class is now being used. No longer need to modify GL Files         *
* Rename SiteCalendar - and is now self contained - no modifications requried   *
*                                                                               *
* Apr 13/2004: Niels Leenheer                                                   *
* Large rewrite to ensure the calender only uses one query to fetch all events  *
* instead of one query for each day. This reduces the number of queries by      *
* 27 or 34. Also, multiple bugs are fixed such as:                              *
* - Multiple events on the same say are now properly shown                      *
* - If there were multiple events on the same day and the first event was       *
*   off limits for the current user, the other events were not taken into       *
*   acount, and as a result that day was not marked as a day with an event      *
* - Weekday abbreviations are now displayed according to the current locale     *
* - Removed <html> and <body> tags from the output, because the output is used  *
*   in an already existing html document.                                       *
*                                                                               *
* Mar 29/2006: Blaine Lang                                                      *
* Updated for Geeklog Version 1.4                                               *
*                                                                               *
* Mar 3/2007: (Blaine Lang) Updates for GL 1.4.1                                *
* Modified to use templates for layout                                          *
*                                                                               *
*********************************************************************************/

/* Version 2.6 - Mar 3/2007 */


define ("_MYCAL_DAY_", 60 * 60 * 24);


function display_calendar()  {
    global $_TABLES, $_CONF;
    
    setlocale(LC_TIME, '');
    
    if( !isset($_POST['month']) ) {
        $workDate = date("m/d/Y");
    } else {
        $workDate = $_POST['month'];
        $GLOBALS['workDate'] = $workDate;
    }

    // Determine the first and last day to display
    $base                 = strtotime($workDate) + 60 * 60 * 12;
    $firstdayofmonth     = $base - ((date("d", $base) - 1) * _MYCAL_DAY_);
    $daysinmonth         = date("t", $firstdayofmonth);
    $lastdayofmonth     = $firstdayofmonth + (($daysinmonth - 1) * _MYCAL_DAY_);
    $firstdaytodisplay     = $firstdayofmonth - (strftime ('%w', $firstdayofmonth) * _MYCAL_DAY_);
    $lastdaytodisplay     = $lastdayofmonth + ((6 - strftime ('%w', $lastdayofmonth)) * _MYCAL_DAY_);
    $totaldays            = ((($lastdaytodisplay - $firstdaytodisplay) / _MYCAL_DAY_) + 1);
    $totalweeks            = $totaldays / 7;

    $firststr = date("Y-m-d", $firstdaytodisplay);
    $laststr  = date("Y-m-d", $lastdaytodisplay);

    // Get the events
    $events   = array();
    $fields = 'eid,title,url,description,datestart,dateend,group_id,owner_id,perm_owner,perm_group,perm_members,perm_anon';
    $sql = "SELECT $fields FROM {$_TABLES['events']} WHERE datestart >= '$firststr' AND datestart <= '$laststr' ";
    $eventRes = DB_query($sql);

    $p = new Template($_CONF['path_html'] . 'mycal');
    $p->set_file (array (
        'calendar'        =>    'calendar.thtml',
        'heading'         =>    'calheading',
        'week'            =>    'calweek_row.thtml',
        'day'             =>    'calday.thtml'));

    $p->set_var ('site_url',$_CONF['site_url']);
    $p->set_var('title_monthyear',ucfirst(strftime("%B %Y", $base)));

    while ($event = DB_fetchArray($eventRes)) {
        $events[$event['datestart']][$event['eid']] = $event;
    }
    $p->set_var('title_weekday',ucfirst(strftime("%B %Y", $base)));
    for ($i = 0; $i < 7; $i++)  {
        $p->set_var('title_weekday', ucfirst(strftime("%a", $firstdaytodisplay + ($i * _MYCAL_DAY_))));
        $p->parse('dayofweeks_title','heading',true);
    }
    for ($w = 0; $w < $totalweeks; $w++) {
        $BlockDisplay .= "<tr>";
        for ($d = 0; $d < 7; $d++)  {
            mycal_eventurl($p,$events, $firstdaytodisplay + (_MYCAL_DAY_ * ($d + ($w * 7))), $base);
            if ($d == 0) {
                $p->parse('calendar_days','day');
            } else {
                $p->parse('calendar_days','day',true);
            }
        }

        $p->parse('calendar_week','week',true);
    }
    $p->set_var('prevmonth', date("m/d/Y", strtotime($workDate . "-1 month")));
    $p->set_var('nextmonth', date("m/d/Y", strtotime($workDate . "+1 month")));
    $p->set_var('lang_clickondate',_mycal_ClickonDate);

    $p->parse ('output', 'calendar');
    return $p->finish ($p->get_var('output'));
}


function mycal_eventurl(&$template,&$events, $timestamp, $base) {
    global $_TABLES, $_CONF;

    $HighlightToday = false;

    if (date("d/m/Y") == date("d/m/Y", $timestamp))  {
        $HighlightToday = true;
    }

    $day  = date("d", $timestamp);
    $key  = date("Y-m-d", $timestamp);
    $date = date("m/d/Y", $timestamp);
    $eventsfound = '';
    $link = '';
    $eventcnt = 0;

    if (count($events[$key]))  {
        $eventcnt = 1;
        while (list($eid,$v) = each($events[$key])) {
            if (SEC_hasAccess($v['owner_id'],$v['group_id'],$v['perm_owner'],$v['perm_group'],$v['perm_members'],$v['perm_anon']) > 0) {
                if ($eventcnt >= 1) {
                    if ($HighlightToday) {
                        $template->set_var('dayclass','mycalEventHighlight mycalTodayHighlight');
                    } else {
                        $template->set_var('dayclass','mycalEventHighlight');
                        /* need to check for GL 1.4 as well as pre 1.4 - when calendar was made into a plugin */
                        if (file_exists($_CONF['path_html'] . '/calendar_event.php')) {
                            $calendar_url  = $_CONF['site_url'] . '/calendar_event.php';
                            $calendar_url2 = $_CONF['site_url'] . '/calendar.php';
                        } else {
                            $calendar_url = $_CONF['site_url'] . '/calendar/index.php';
                        }
                    }
                    if ($eventcnt == 1) {
                        $eventsfound .= "<div style=\"display:inline;font-weight:bold;\">{$v['title']}</div><div style=\"padding:5px;\">{$v['description']}</div>";
                        $link = "<a class=\"tooltip\" ";
                        $link .= "href=\"{$calendar_url}?eid={$eid}\">";
                        $link .= "<b>$day</b><span style=\"left:-145px;top:12px\">{$eventsfound}</span></a>";
                    } else {
                        $dateinfo = explode('-',$v['datestart']);
                        $link = "<a class=\"tooltip\" ";
                        $link .= "href=\"{$calendar_url2}?view=day&year={$dateinfo[0]}&month={$dateinfo[1]}&day={$dateinfo[2]}\">";
                        $link .= "<b>$day</b><span>{$eventsfound}</span></a>";
                    }
                    $template->set_var('daylink',$link);
                }
                $eventcnt++;
            }
        }
    }
        
    if ($eventcnt == 0)  {

        if (date("m", $base) != date("m", $timestamp))  {
            $link = "<a class=\"mycallink\" href=\"{$_CONF['site_url']}/mycal/calsearch.php?";
            $link .= "datestart={$key}&dateend={$key}&type=all&mode=search&topic=0&author=0\">{$day}</a>";
            $template->set_var('dayclass','mycalNextMonth');
            $template->set_var('daylink',$link);
        } else {
            if ($HighlightToday) {
                $template->set_var('dayclass','mycalTodayHighlight');
            } else {
                $template->set_var('dayclass','mycalDateField');
            }
            $link = "<a class=\"mycallink\" href=\"{$_CONF['site_url']}/mycal/calsearch.php?";
            $link .= "datestart={$key}&dateend={$key}&type=all&mode=search&topic=0&author=0\"><b>{$day}</b></a>";
            $template->set_var('daylink',$link);
        }

    }

}

?>